%% Pend_CSIDE_ReadEEMs 
%
% start in the directory that contains this file: Pend_CSIDE_data_n_code 
%
% unzip EEMs_all_raw and 'cd' into that directory
%
%%
%
preprocessingNeeded = 1; % turns this on/off

if preprocessingNeeded == 1
    % first part of code just builds the structure C from the data
    % ... saved in different directories from the spectrometer(Horiba Aquafluor)    
    DIR = pwd; % first you have to make 'pwd' a variable, apparently
    d = dir(DIR); % then you can make it a directory
    for k=1:numel(d)
        folders=d(k+2).name;  % names of folders (parent directories) from each day
        % its k+2 b/c first 2 elements in d are '.' and '..'
        cd([folders])
        PEM = dir('*PEM.dat'); % this grabs all the PEM files in each folder
        for j=1:numel(PEM) % j is looping through the PEM.dat files in the d(k+2).name folder
            A(j) = importdata([ pwd '\' PEM(j).name ]);
            % A(j) has the data for each PEM.dat file in each parent directory
            % here (above) the PEMs get named
        end
        %
        [A.name]=PEM.name; % then names are added to A
        [C(k).PEMfiles]=A; % PEMfiles is one column in C. it is a structure...
        % ... w/ columns:..
        % ... data (EEMs w/ excitation wavelengths in first row)...
        % ... textdata (emission wavelengths)...
        % ... rowheaders (also the emission wavelengths)...
        [C(k).foldername]=folders; % foldername is another column in C
        clear A
        cd ..
    end
    %
    % normalization factors from:
    RamanAreas = load('Pend_CSIDE_RamanAreas.txt');
    NFmed = RamanAreas(:,1);
    NFhi = RamanAreas(:,2);
    %
    % raw data are normalized by the appropriate daily normalization factors
    for n=1:numel(C)
        for m=1:numel(C(n).PEMfiles)
            if n==1 ||...
                    n==2 && m==10 ||...
                    n==2 && m==11 ||...
                    n==2 && m==12 ||...
                    n==2 && m==13 ||...
                    n==2 && m==14 ||...
                    n==2 && m==15 ||...
                    n==5
                O = C(n).PEMfiles(m).data/NFmed(n);  % normalize w/ NFmed
                [C(n).PEMfiles(m).Normdata2] = O;    % add it to C
                % check using Q; just a check to make sure are same
                Q = C(n).PEMfiles(m).Normdata2*NFmed(n)-C(n).PEMfiles(m).data;
                Q = roundn(Q,-5);  % round to 5 digits to make sure it is exactly zero
                [C(n).PEMfiles(m).Normdata2check] = Q;
                FN = NFmed(n);
                [C(n).PEMfiles(m).NormFactor] = FN;
                [C(n).PEMfiles(m).Gain] = 'medium gain';
            else % normalize w/ NFhi
                O = C(n).PEMfiles(m).data/NFhi(n);
                [C(n).PEMfiles(m).Normdata2]=O;
                % check using Q; just a check to make sure are same
                Q = C(n).PEMfiles(m).Normdata2*NFhi(n)-C(n).PEMfiles(m).data;
                Q = roundn(Q,-5); % round to 5 digits to make sure it is exactly zero
                [C(n).PEMfiles(m).Normdata2check] = Q;
                FN = NFhi(n);
                [C(n).PEMfiles(m).NormFactor] = FN;
                [C(n).PEMfiles(m).Gain] = 'high gain';
            end
            clear O
            clear Q
            clear FN
        end
    end
end
%
%
%% Find the excitation-emission pair for the max fluoresence...
... from the 5 highest points from each of the 3 cal curves...
... and then search for the max fluorescence from only those ex-em pairs in the samples
            %% 11/21/18 here is the code used to find the ex/em pair for the max fluorescence value for each cal curve scan
            % the values are listed below
            % later on / further below I used the compilation of those ex,em pairs (finding just the unique pairs)
            % and I took the max fluorescence value from each sample scan
            % instead of searching in a window that includes the 1:1 scatter line
            %
%% 1/15/19  Find the ex/em points of max RWT dye fluorescence ...
... Using the 5 most concentrated calibration curve points:
%
%   doing just C(5) - the cal curve data
%   ... from the 5 highest points from each of the 3 cal curves...
    for q = [6 7 8 9 10 16 17 18 19 20 26 27 28 29 30]
        ex = C(5).PEMfiles(q).data(1,:); 
        exi = find(ex<566 & ex>549); % 'exi' = excitation indices
        % excitation wavelengths decr. Left to Right
        em = C(5).PEMfiles(q).textdata(:,1);
        EM = zeros(numel(em),1);
        EM(4:end) = str2double(em(4:end));
        em = EM;
        emi = find(em>569 & em<601);    % last emission wavelengths incr. down the column
        % nnRWTw = new new RWT window
        % nnRWTw = C(k).PEMfiles(q).Normdata2(emi,exi); % pulls the Normdata2 data w/in the emi,exi indices/limits
        nnRWTw = C(5).PEMfiles(q).Normdata2(emi,exi);
        [C(5).PEMfiles(q).nnRWTw] = nnRWTw;             % and then puts into the structure
        % 1/15/19 - want just for C(5)
        [M,I] = max(nnRWTw(:));   % max is in C as RWTm; (:) finds max across all rows and columns
        % have nnRWTw for each sample, not just C(5)
        % 1/15/19 - today just doing for C(5)
        [i1,i2] = ind2sub(size(nnRWTw),I); %
        % ind2sub finds the row,col indices of values. 
        % It gives the indices within the RWT window (nnRWTw) 
        % and then those are related to the whole EEM below
        ismax = C(5).PEMfiles(1).Normdata2(i1+emi(1)-1,i2+exi(1)-1);
        % above finds the max value in the original EEM by "adding the indices"
        % of the window to the emi,exi indices of the original EEM, bc max was
        % found in the new new RWT window (nnRWTw)
        % I don't know if ismax is necessary bc I just want the indices
        % for the big matrix of the max found in the nnRWTw
        % exi corresponds to i2
        exi_max = i2+exi(1)-1;   % yields 14 for the index value
        ex_max = C(5).PEMfiles(q).data(1,exi_max);
        % emi corresponds to i1
        emi_max = i1+emi(1)-1;
        % em_max = C(k).PEMfiles(1).textdata(emi_max,1); % gives 1x1 cell array
        em_max = C(5).PEMfiles(q).textdata(emi_max,1); % gives 1x1 cell array
        % as above. PEMfiles(1) probably fine, using PEMfiles(q) JIC
        EM_MAX = str2double(em_max(:));
        em_max = EM_MAX;
        [C(5).PEMfiles(q).cal5max] = M;
        [C(5).PEMfiles(q).cal5exmax] = ex_max;
        [C(5).PEMfiles(q).cal5emmax] = em_max;
        [C(5).PEMfiles(q).cal5eximax] = exi_max; % 1/15/19. index
        [C(5).PEMfiles(q).cal5emimax] = emi_max; % 1/15/19. index
        clear nnRWTw M I i1 i2 ismax exi_max ex_max emi_max em_max EM_MAX
    end
%
%%   1/15/19 - above ran
% above now gives the ex/em pairs of max fluorescence from the 5 highest cal curve points
%
%% C contains:
%
% C.name:
% {'Blanks_10072015';
% 'DyeRelease1_09232015';
% 'DyeRelease2_09242015';
% 'DyeRelease3_09252015';
% 'RhodamineWT_Calibration3';
% 'SecondRelease_d1_20151008';
% 'SecondRelease_d2_20151009';
% 'SecondRelease_d3_20151010';
% 'ThirdRelease_d1_20151012';
% 'ThirdRelease_d2_20151013';
% 'ThirdRelease_d3_20151014';
% 'ThirdRelease_d4_20151015'}
%
%% using:
% https://www.mathworks.com/matlabcentral/answers/331309-matlab-find-unique-column-combinations-in-matrix-and-respective-index
% [B, ~, ib] = unique(A, 'rows');
% numoccurences = accumarray(ib, 1);
% indices = accumarray(ib, find(ib), [], @(rows){rows});  %the find(ib) simply generates (1:size(a,1))'
%
A = [C(5).PEMfiles.cal5exmax; C(5).PEMfiles.cal5emmax];
A = A';
%
% find the ex/em wavelength pairs that most frequently have the max fluorescence
[G, ~,ig] = unique(A, 'rows');
numoccurences = accumarray(ig, 1);
indices = accumarray(ig, find(ig), [], @(rows){rows});
%
%% 1/15/19 now we have three ex/em points to use for quantification
% G = ...
%   [555.0000  579.9330
%   560.0000  579.9330
%   560.0000  584.6390];
%
    %% 11/20/18 - plot them to show they are not on the 1:1 scatter line
    % 1/15/19 - good, they are not
    xy = [500   500
        600 600];
    f1 = figure;
    scatter(G(1:3),G(4:6));
    hold on
    plot(xy(1:2),xy(3:4));
    axx = gca;
    axx.XLabel.String = 'excitation \lambda, nm';
    axx.XLabel.FontWeight = 'bold';
    axx.XLabel.FontSize = 12;
    axx.YLabel.String = 'emission \lambda, nm';
    axx.YLabel.FontWeight = 'bold';
    axx.YLabel.FontSize = 12;
    %
    set(findall(gcf,'-property','FontSize'),'FontSize',12);
    set(findall(gcf,'-property','LineWidth'),'LineWidth',1.5);
    %
    % print -f3 -r600 -dpng locs_max_fluor
    % print -f3 -r600 -djpeg locs_max_fluor
    
    %%
    % nnRWTw = C(5).PEMfiles(5).Normdata2(emi,exi);
    % pulls the Normdata2 data w/in the emi,exi indices/limits
    %
    % compare to
    % RWT_G = C(5).PEMfiles(5).Normdata2(G); % can't use the values, need the indices
    % G has the values. I need to find where those values are in the excitation
    % and emission vectors
    % the RWTwindow for plotting and for finding the max RWT peak
    % 
    %% reload these if I didn't save my workspace to make the compiled list of the indices for G
    %
    % I have exi_max and emi_max but I don't have the list of indices for just
    % the unique values, so do it here.
    % I have to find them in ex and em, which are the same for all samples
    ex = C(5).PEMfiles(1).data(1,:); % 'exi' = excitation indices
    % exi = find(ex<580 & ex>530); % excitation wavelengths decr. Left to Right in d
    em = C(5).PEMfiles(1).textdata(:,1);
    EM = zeros(numel(em),1);
    EM(4:end) = str2double(em(4:end));
    em = EM;
    clear EM
    
    % exii = find(ex==550);  % correct, ex(16) = 550
    % G1i = find(ex==(G(1)));
    %
    % Gexis = zeros(11,2);
    % for i = 1:11
    %     Gexis(i) = find(ex==G(i));
    % end
    % %% do it for emission indices
    % for ii = 12:22
    %     Gexis(ii) = find(em==G(ii));
    % end

    G_exi_emi = zeros(size(G));
    %
    for i = 1:3
        G_exi_emi(i) = find(ex==G(i));
    end
    for j = 4:6
        G_exi_emi(j) = find(em==G(j));
    end
    %
    % G_exi_emi =
    %
    %     15    76
    %     14    76
    %     14    77  % looks good
    %    exi    emi
    %
    %
    % now I just pull the data from the EEM at those indices
    %
    %
%
%
%% new background correction; added to 2019mar19.mat
X = C(1).PEMfiles(1).data(1,:); % excitation wavelengths (no need to loop)
Y = C(1).PEMfiles(1).textdata(4:end,1); % emission wavelengths (no need to loop)
Y = str2double(Y);
% excitation. working in this range:
% 555   550   545   540   535  530   525   520   515   510   505   500
background_x = [509 521]; % captures 510 515 520
% emission. working in this range:
% {'490.964'} {'495.624'} {'500.287'} {'504.953'} {'509.621'}
% {'514.292'} {'518.965'} {'523.641'} {'528.319'} {'533'    } {'537.683'}
% {'542.368'} {'547.056'} {'551.746'} {'556.438'} {'561.133'} {'565.83' }
background_y = [513 548];
% captures
% {'514.292'} {'518.965'} {'523.641'} {'528.319'} {'533'}{'537.683'}
% {'542.368'} {'547.056'}
[xx,yy] = meshgrid(X,Y);
[inp] = inpolygon(xx,yy,background_x,background_y);
        left = background_x(1);
        right = background_x(2);
        width = right-left;
        bot = background_y(1);
        top = background_y(2);
        height = top-bot;
% inp is indices of the points used for background correction
%
%% added to C; this was missing
part1 = C(2).PEMfiles(12).Normdata2(4:end,:); 
part2 = C(3).PEMfiles(1).Normdata2(4:end,:);
hybrid = part1 + part2;
% now plug in hybrid below as Z0 to plot it
%
%% plot the background correction
Z = hybrid;
Zb = nanmean(Z(inp)); % its background
f = figure('visible','off');
subplot(1,2,1); ax1 = gca; 
pcolorcen(X,Y,Z); colormap(flipud(bone)); caxis([0 0.3]); colorbar;
hold on
rectangle('Position',[left bot width height]);
ax1.XLabel.String = 'excitation \lambda, nm';
ax1.YLabel.String = 'emission \lambda, nm';
% add extraction points: 3 ex/em points where we grab fluor intensities
hold on
plot(ex(G_exi_emi(1:3)),em(G_exi_emi(4:6)),'ro','markersize',4)

kx1 = dsearchn(X',G(:,1)); ky1 = dsearchn(Y,G(:,2));
fi1 = nan(1,3);
for ffi = 1:3
    fi1(ffi) = Z(ky1(ffi),kx1(ffi));
end
fi_mean1 = mean(fi1);
title('hybrid_2_12_3_1_uncorreccted','interpreter','none');

% second plot is the background corrected EEM
subplot(1,2,2); ax2 = gca;
Zbc = Z - Zb; % the background corrected data
Zbb = nanmean(Zbc(inp)); % background of background corrected data
% Zbb was Zb2 & it should be v. near zero
pcolorcen(X,Y,Zbc); colormap(flipud(bone)); caxis([0 0.3]); colorbar
hold on
rectangle('Position',[left bot width height]);
ax2.XLabel.String = 'excitation \lambda, nm';
ax2.YLabel.String = 'emission \lambda, nm';
% add extraction point
hold on
plot(ex(G_exi_emi(1:3)),em(G_exi_emi(4:6)),'ro','markersize',4)
kx2 = dsearchn(X',G(:,1)); ky2 = dsearchn(Y,G(:,2));
% this was the problem:
% kx2 = dsearchn(X',G_exi_emi(:,1));
% ky2 = dsearchn(Y,G_exi_emi(:,2));
fi2 = nan(1,3);
for ffi = 1:3
    fi2(ffi) = Zbc(ky2(ffi),kx2(ffi)); % was Z2
end
fi_mean2 = mean(fi2);

title('hybrid_2_12_3_1_corrected','interpreter','none');
%% save it
print(gcf,'-dpng',['EEM_hybrid_509_521_513_548']);
%
%
%% here just calculate the values and don't plot
% adapted from last background correction
for ci = 1:numel(C)
    for pi = 1:length(C(ci).PEMfiles)
        BG_2 = nanmean(C(ci).PEMfiles(pi).Normdata2(inp));
            [C(ci).PEMfiles(pi).BG2] = BG_2;
            bgcND2_2 = C(ci).PEMfiles(pi).Normdata2-BG_2; %...and substracting that from the entire matrix.
            [C(ci).PEMfiles(pi).bgcND2_2] = bgcND2_2; % background corrected NormData2
            clear BG_2 bgcND2_2  % BG_2 was BG2 but doesn't matter bc it just gets over-written anyway 
        end
end
%
%
%% this gives avg background corrected NormData2
% AVG of the 3 background corrected NormData2 matrices (bgcND2)
% AVbgcND2Fluor_2 is then the average fluor from the 3 RWT ex/em locations
% doing it this way reduces the # of matrices earlier on
for k = [1 2 3 4 6 7 8 9 10 11 12]  % C(5) & C(6) are irregular so don't do here
    for j=2:3:numel(C(k).PEMfiles)-1
        % takes avg of value, val above, val below;
        % the '2' & '-1' keeps it from applying to the first and last vals in col.
        AVbgcND2_2 = (C(k).PEMfiles(j).bgcND2_2 + C(k).PEMfiles(j-1).bgcND2_2 + C(k).PEMfiles(j+1).bgcND2_2)/3;
        [C(k).PEMfiles(j).AVbgcND2_2] = AVbgcND2_2;  % so these are the matrices
        clear AVbgcND2_2
        % AVbgcND2Fluor_2 takes the fluorescence at the 3 RWT peaks and averages them
        AVbgcND2Fluor_2 = (C(k).PEMfiles(j).AVbgcND2_2(G_exi_emi(4),G_exi_emi(1))... % EEMs: rows-emission, cols-excitation
            + C(k).PEMfiles(j).AVbgcND2_2(G_exi_emi(5),G_exi_emi(2))...
            + C(k).PEMfiles(j).AVbgcND2_2(G_exi_emi(6),G_exi_emi(3)))/3;
        [C(k).PEMfiles(j).AVbgcND2Fluor_2] = AVbgcND2Fluor_2;  % and this is the avg of the 3 RWT peaks (for a given matrix)
    end
end
%
% make corrections to C(6) bc it is irregular - Sample5 was read just twice
C(6).PEMfiles(11).AVbgcND2_2 = 0;
% C(6).PEMfiles(11).AVmxRWTpk = (C(6).PEMfiles(10).maxRWTpeak + C(6).PEMfiles(11).maxRWTpeak)/2;
C(6).PEMfiles(11).AVbgcND2_2 = ...
    (C(6).PEMfiles(10).bgcND2_2 + ...
     C(6).PEMfiles(11).bgcND2_2)/2;
C(6).PEMfiles(11).AVbgcND2Fluor_2 = ...
    (C(6).PEMfiles(11).AVbgcND2_2(G_exi_emi(4),G_exi_emi(1)) + ... % EEMs: rows-emission, cols-excitation
     C(6).PEMfiles(11).AVbgcND2_2(G_exi_emi(5),G_exi_emi(2)) + ...
     C(6).PEMfiles(11).AVbgcND2_2(G_exi_emi(6),G_exi_emi(3)))/3;
C(6).PEMfiles(14).AVbgcND2_2 = [];
C(6).PEMfiles(13).AVbgcND2_2 = ...
    (C(6).PEMfiles(13).bgcND2_2 + ...
     C(6).PEMfiles(12).bgcND2_2 + ... 
     C(6).PEMfiles(14).bgcND2_2)/3;
C(6).PEMfiles(13).AVbgcND2Fluor_2 = ...
    (C(6).PEMfiles(13).AVbgcND2_2(G_exi_emi(4),G_exi_emi(1)) + ... % EEMs: rows-emission, cols-excitation
     C(6).PEMfiles(13).AVbgcND2_2(G_exi_emi(5),G_exi_emi(2)) + ...
     C(6).PEMfiles(13).AVbgcND2_2(G_exi_emi(6),G_exi_emi(3)))/3;
C(6).PEMfiles(16).AVbgcND2_2 = ...
    (C(6).PEMfiles(16).bgcND2_2 + ...
     C(6).PEMfiles(15).bgcND2_2 + ...
     C(6).PEMfiles(17).bgcND2_2)/3;
C(6).PEMfiles(16).AVbgcND2Fluor_2 = ...
    (C(6).PEMfiles(16).AVbgcND2_2(G_exi_emi(4),G_exi_emi(1)) + ... % EEMs: rows-emission, cols-excitation
     C(6).PEMfiles(16).AVbgcND2_2(G_exi_emi(5),G_exi_emi(2)) + ...
     C(6).PEMfiles(16).AVbgcND2_2(G_exi_emi(6),G_exi_emi(3)))/3;
C(6).PEMfiles(14).AVbgcND2Fluor_2 = [];
%
%
%% see the cal curve file for their averaging: Pend_CSIDE_CalCurve.m
% * - note: the calibration curve data (C(5).PEMfiles) are:
% 10 concentrations all scanned once (1:10), then all 10 scanned again
% (11:20), and then all scanned once more (21:30)
%
%% use folder_scan_Fluor_PPB_2019mar19 & skip this section
        %% here I make a table of those values but this is provided:

        scanAVGs6 ={};
        for k=[1 2 3 4 7 8 9 10 11 12] % leave out C(5) - cal curve data & C(6) - irregular 
            for j=2:3:numel(C(k).PEMfiles)-1
                i=numel(j);
                zz = cell(1,3);
                zz{i,1} = sprintf('%s',C(k).foldername);
                zz{i,2} = sprintf('%s',C(k).PEMfiles(j).name);
                zz{i,3} = C(k).PEMfiles(j).AVbgcND2Fluor_2;
                scanAVGs6 = vertcat(scanAVGs6,zz);
                clear zz
            end
        end
        % above only worked for k=[1 2 3 4];
        for k=6
            for j=[2 5 8 11 13 16]
                i=numel(j);
                zz = cell(1,3);
                zz{i,1} = sprintf('%s',C(k).foldername);
                zz{i,2} = sprintf('%s',C(k).PEMfiles(j).name);
                zz{i,3} = C(k).PEMfiles(j).AVbgcND2Fluor_2;
                scanAVGs6 = vertcat(scanAVGs6,zz);
                clear zz
            end
        end
        %
        for k=[7 8 9 10 11 12]
            for j=2:3:numel(C(k).PEMfiles)-1
                i=numel(j);
                % z{j,:} = zeros(numel(j),3);
                zz = cell(1,3);
                % SA{1,1} = sprintf('%s',C(1).name,C(1).PEMfiles(2).name);
                zz{i,1} = sprintf('%s',C(k).foldername);
                zz{i,2} = sprintf('%s',C(k).PEMfiles(j).name);
        %         zz{i,3} = C(k).PEMfiles(j).AVmxRWTpk;
                zz{i,3} = C(k).PEMfiles(j).AVbgcND2Fluor_2;
                scanAVGs6 = vertcat(scanAVGs6,zz);
                clear zz
            end
        end
        % works
        % three columns: folder, scan, fluorescence (RU (Raman Units))
        %% then save it:
        save folders_scans_AVbgcND2Fluor_2.mat scanAVGs6
        %
        %% then I need to make the calibration curve using those data from C(5)
        % done in Pend_CSIDE_CalCurve.m
        %
        %% now apply cal curve to data to get PPB for liquid samples
        % do x = (y-b)/m | ppb = (RU-b)/m to calc ppb of samples
        % ppb - parts per billion ; RU - Raman Units
        load folders_scans_AVbgcND2Fluor_2.mat % 3/19/19. loads as scansAVGs6
        %%
        samplesPPB_2 = zeros(length(scanAVGs6),1);
        % it is a 54x3 cell: folder, scan, RU
        %% 3/19/19 - CALCULATE PPB FROM RU
        for s = 1:length(scanAVGs6)
            samplesPPB_2(s) = (scanAVGs6{s,3}-b(1))/b(2);
        end
        %
        %% tack it on
        samplesPPB2_2 = num2cell(samplesPPB_2);
        scanAVGs6 = horzcat(scanAVGs6,samplesPPB2_2); % worked
        % scanAVGs6: folder, scan, RU, PPB
        %% save it as its own file ...
        % save scanAVGs6.mat scanAVGs6
        save folders_scans_bgcFluor_bgcPPB.mat scanAVGs6
        %
        %
        %
        %% 2018 nov 23
        % next: final air sample list from scanAVGs6.mat
        % remove water samples
        %
        %% start by creating a new scanAVGs file by saving "6" under a new name and work with new one
        %
        scanAVGs7 = scanAVGs6;
        %%
        save scanAVGs7.mat scanAVGs7
        %
        %% moved this up one section: there are repeat entries in scanAVGs
        % remove rows 19-33
        badrows=[19:33];
        scanAVGs7(badrows,:) = [];
        %
        E = cell2table(scanAVGs7,'VariableNames',{'folder','scan','fluor_RU','RWT_PPB'});
        %
        % these two need to have same name bc contain same data, just dif. format
        writetable(E,'folder_scan_Fluor_PPB_2019mar19.dat'); 
        save folder_scan_Fluor_PPB_2019mar19.mat scanAVGs7
        %
        %% 2020dec18 I'll include these data with the manuscript: 
        % folder_scan_Fluor_PPB_2019mar19.dat
        % so load them if above is not working

%% water samples, blanks, & rinse(s) to remove from scanAVGs7 (remove whole row)
% folder: Blanks_10072015;
% samples: water 1 & 2;                         rows: 3,4
% folder: DyeRelease1_09232015
% samples: 2 (rinse), 3 (hi gain), water1;      rows: 6,7,9
% folder: {'DyeRelease2_09242015'}
% samples: water1;                              rows: 13
% folder: {'DyeRelease3_09252015'}
% samples: water001;                            rows: 18
% folder:
%
%% add start and end timestamps
start = zeros(39,1);
%
        %% Then this is just to make the figure Pend_CSIDE_FigureS2 in the supplemental materials
        X = C(1).PEMfiles(1).data(1,:);  % excitation
        Y = C(1).PEMfiles(1).textdata(4:end,1); % emission
        Y = str2double(Y); % converted
        %
        %    C(5).PEMfiles(m).AVbgcND2calFluor_2
        Z1 = C(5).PEMfiles(8).Normdata2(4:end,:); % RWT standard from cal curve
        % C(5).PEMfiles(8) is 2 PPB.
        % PPB values for cal curve:
        % bgcCal_2(1:10) = [0; 0.005; 0.05; 0.1; 0.2; 0.5; 1; 2; 5; 15];
        %                   1   2       3   4      5    6   7 8  9  10
        %
        Z2 = C(9).PEMfiles(8).Normdata2(4:end,:); % RWT detected - strong
        % 9. 'ThirdRelease_d1_20151012'; {'Samp003Scan0002PEM.dat'} DR3d1 TNTS
        % sample 19
        % 3.274899062 PPB 
        Z3 = C(10).PEMfiles(2).Normdata2(4:end,:); % RWT detected - weak
        % DR3,d2, TRLS (TNTS); sample 22
        % 0.938396532 PPB
        Z4 = C(1).PEMfiles(1).Normdata2(4:end,:); % blank - good one for no dye detected
        % MVHS 10/07/15 day blank;  0.225419314  PPB; sample 27
        %
        %
        fig3 = figure;
        fig3.Units = 'inches';
        fig3.OuterPosition = [0 0 4.85 4.85]; % resize to close to final size
        %
        % 1.A. set up your axes
        ax1 = axes('Units','inches','Position',[0.5 2.2 1.6 1.6]); % [left bot width height]
        %
        % 2.A. plot it into those axes
        contourf(ax1,X,Y,Z1,'LineColor','none'); hold on
        colormap(flipud(bone));
        caxis([0 0.5]);
                rectangle('Position',[left bot width height]); hold on
                % add extraction points
                plot(ex(G_exi_emi(1:3)),em(G_exi_emi(4:6)),'ro','markersize',2,'LineWidth',1.5);
                hold on
                text(600,670,'A','FontSize',10,'FontWeight','bold');
        %
        % 3.A. flesh out axes
        % excitation data: 425-625
        ax1.XLim = [425 625];
        ax1.XTick = [450 525 600];
        ax1.XTickLabel = {}; % don't need in topleft
        % emission data: 248-827
        ax1.YLim = [400 700];
        ax1.YTick = [450 550 650];
        ax1.YTickLabel = {450 550 650};
        ax1.YLabel.String = 'emission \lambda, nm';
        ax1.YLabel.FontWeight = 'bold';
        ax1.YLabel.FontSize = 9;
        ax1.Layer = 'top';
        box on;
        ax1.LineWidth = 1.75;
        ax1.FontSize = 9;
        %
        % 1.B. set up axes
        ax2 = axes('Units','inches','Position',[2.2 2.2 1.6 1.6]); % [left bot width height]
        %
        % 2.B. plot it
        contourf(ax2,X,Y,Z2,'LineColor','none'); hold on
        colormap(flipud(bone));
        caxis([0 0.5]);
                rectangle('Position',[left bot width height]); hold on
                % add extraction points
                plot(ex(G_exi_emi(1:3)),em(G_exi_emi(4:6)),'ro','markersize',2,'LineWidth',1.5);
                hold on
                text(600,670,'B','FontSize',10,'FontWeight','bold');
        %
        % 3.B. flesh out axes
        % ex in data: 425-625
        ax2.XLim = [425 625];
        ax2.XTick = [450 525 600];
        ax2.XTickLabel = {}; % don't need in topleft
        % em in data: 248-827
        ax2.YLim = [400 700];
        ax2.YTick = [450 550 650];
        ax2.YTickLabel = {};
        ax2.Layer = 'top';
        box on;
        ax2.LineWidth = 1.75;
        ax2.FontSize = 9;
        % ax2.pbaspect = [1 1 1];
        %
        % 1.C. set up your axes
        ax3 = axes('Units','inches','Position',[0.5 0.5 1.6 1.6]); % [left bot width height]
        %
        % 2.C. plot it
        contourf(ax3,X,Y,Z3,'LineColor','none'); hold on
        colormap(flipud(bone));
        caxis([0 0.5]);
                rectangle('Position',[left bot width height]); hold on
                % add extraction points
                plot(ex(G_exi_emi(1:3)),em(G_exi_emi(4:6)),'ro','markersize',2,'LineWidth',1.5);
                hold on
                text(600,670,'C','FontSize',10,'FontWeight','bold');
        % 3.C. flesh out axes
        % ex in data: 425-625
        ax3.XLim = [425 625];
        ax3.XTick = [450 525 600];
        ax3.XTickLabel = {450 525 600};
        % em in data: 248-827
        ax3.YLim = [400 700];
        ax3.YTick = [450 550 650];
        ax3.YTickLabel = {450 550 650};
        ax3.XLabel.String = 'excitation \lambda, nm';
        ax3.XLabel.FontWeight = 'bold';
        ax3.XLabel.FontSize = 9;
        ax3.YLabel.String = 'emission \lambda, nm';
        ax3.YLabel.FontWeight = 'bold';
        ax3.YLabel.FontSize = 9;
        ax3.Clipping = 'on';
        ax3.Layer = 'top';
        box on;
        ax3.LineWidth = 1.75;
        ax3.FontSize = 9;
        hold on;
        %
        % 1.D. initiate your axes
        ax4 = axes('Units','inches','Position',[2.2 0.5 1.6 1.6]); % [left bot width height]
        %
        % 2.D. plot it
        contourf(ax4,X,Y,Z4,'LineColor','none'); hold on
        colormap(flipud(bone));
        caxis([0 0.5]);
                rectangle('Position',[left bot width height]); hold on
                % add extraction points
                plot(ex(G_exi_emi(1:3)),em(G_exi_emi(4:6)),'ro','markersize',2,'LineWidth',1.5);
                hold on
                text(600,670,'D','FontSize',10,'FontWeight','bold');
        %
        % 3.D. then finish setting up axes
        % ex in data: 425-625
        ax4.XLim = [425 625];
        ax4.XTick = [450 525 600];
        ax4.XTickLabel = {450 525 600};
        % em in data: 248-827
        ax4.YLim = [400 700];
        ax4.YTick = [450 550 650];
        ax4.YTickLabel = {};
        ax4.XLabel.String = 'excitation \lambda, nm';
        ax4.XLabel.FontWeight = 'bold';
        ax4.XLabel.FontSize = 9;
        ax4.YLabel.String = {};
        ax4.YLabel.FontWeight = 'bold';
        ax4.YLabel.FontSize = 9;
        ax4.Clipping = 'on';
        ax4.Layer = 'top';
        box on;
        ax4.LineWidth = 1.75;
        ax4.FontSize = 9;
        hold on;
        %
        %
        %% need to make a fifth axes and just put the colorbar there
        ax5 = axes('Units','inches','Position',[1.7 0.7 2.1 2.85],'box','off','Color','none'); % [left bot width height]
        ax5.XTick = [];
        ax5.XTickLabel = {};
        ax5.YTick = [];
        ax5.YTickLabel = {};
        ax5.Box = 'off';
        ax5.XColor = 'none';
        ax5.YColor = 'none';
        % for some reason I have to re-state (even highlight and run after) this:
        ax5.Position = [1.7 0.7 2.1 2.85]; % [left bot width height]
        %
        %%
        colormap(flipud(bone));
        caxis([0 0.5]);
        h = colorbar;
        ylabel(h,'fluorescence, RU','FontWeight','bold','YTick',[0 0.1 0.2 0.3 0.4 0.5]);
        ax5.Position = [1.7 0.7 2.1 2.85]; % [left bot width height]
        %
        %%
        paperSize = [0 0 11 8.5]; %where the 4 #s are left, bottom, width, height, so this example would make the figure 11" wide and 8.5" tall
        set(gcf,'paperposition',paperSize);
        set(0,'defaultfigurecolor','white');
        %
        %% save
        print -f1 -r600 -dpng fig2_2019mar21_NoSet_NoPaper
        print -f1 -r600 -djpeg fig2_2019mar21_NoSet_NoPaper

